%!TEX root=../../thesis.tex
%!TEX file=content/appendix/solving-daes.tex

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\chapter{Solving DAEs}\label{app:chap:solving-daes}

Solving \acrlongpl{DAE} is an involved task that requires more sophisticated approaches than integration of conventional \acrshortpl{ODE} since not only does the vector of states~$\state$ have to follow the dynamics given through the \acrshort{ODE}, but constraints have to be fulfilled at every step of integration, too.

In general, a \acrshort{DAE} is given in the form
%
\begin{align*}
  \begin{split}
    \state^{\prime} \of{t}
      & = \vect{f} \of{ \state \of{t}, t} \,
        ,
      \\
    \zeros
      & = \posconstraints \of{ \state \of{t}, t} \,
        ,
      \\
    \state \of{ t_{0} }
      & = \state_{0} \,
        .
  \end{split}
\end{align*}
%
where~$\state$ is the state vector,~$\state^{\prime}$ its derivative,~$\vect{f} \of{\state \of{t}, t}$ defines the differential equation of~$\state^{\prime}$, and~$\posconstraints \of{ \state \of{t}, t }$ defines the algebraic constraints.
This formulation also holds for higher order differential equations \textEg in~$\state^{\prime\prime}$ which may be rewritten with new states~$\state[z] = \transpose{\left[ \state, \state^{\prime} \right]}$ and~$\state[z]^{\prime} = \transpose{\left[ \state^{\prime}, \, \state^{\prime\prime} \right]}$, then reading for~$\state[z]^{\prime} \of{t} = \vect{f} \of{ \state[z], t }$.

It can be seen directly that the algebraic constraints are only given on the position value of~$\state \of{t}$ which makes solving the \acrshort{DAE} for~$\state^{\prime} \of{t}$ more involved.
Without giving explicit details on how to numerically integrate \acrshortpl{ODE} using methods like forward or backward Euler, it may be inferred from secondary literature that these integrators cannot satisfy algebraic constraints at the same time, \textCf \textEg~\textcite{Miranda.1997i}.
It remains an open field of research to find appropriate description for \acrshortpl{DAE} that will allow for explicit integration of the underlying \acrshort{ODE} while also enforcing minimum constraint violation on the underlying algebraic level.
Since mechanical systems are very often composed of multiple coupled bodies interacting with each other, numerically solving \acrshortpl{DAE} is a very dominant part in finding the time response of a mechanical system given an initial value.
Many different approaches to both handling constraint violation and to integration schemes are available in the literature, some of which will be briefly summarized in this chapter.



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\input{content/appendix/solving-daes/constraint-violation-handling}




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\input{content/appendix/solving-daes/numerical-integrators}
